<?php

/************************************************************************************/
/*                                                                                  */
/* Routine: MSAnalysisExportTable - Copyright (c) 2001 by:                          */
/*                                                                                  */
/* Thomas Rudant (thomas.rudant@grunk.net)                                          */
/* http://www.grunk.net                                                             */
/* http://www.securite-internet.org                                                 */
/*                                                                                  */
/************************************************************************************/
/*                                                                                  */
/* Maty Scripts Analysis for PHP-Nuke 6.5                                           */
/* v1.0: 23-02-2003                                                                 */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@matyscripts.com)                    */
/* http://www.matyscripts.com                                                       */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

$index = 0;
$module_name = basename( dirname( __FILE__ ) );

if( !eregi( "modules.php", $PHP_SELF ) ) {
   die ( "You can't access this file directly..." );
}

require_once( "mainfile.php" );

global $admin;
if( is_admin( $admin ) ) {
/******************************************************************************/
/* FUNCTION: MSAnalysisDump()                                                 */
/******************************************************************************/
function MSAnalysisDump()
{
   global $dbname, $prefix, $dbi;

   // Filename to be saved to
   $fn = "Backup MS-Analysis - " . date( "d-m-Y" ) . ".sql";
   // Get version number
   $result = sql_query( "select version from $prefix"._msanalysis_admin." where id='1'", $dbi );
   list( $version ) = sql_fetch_row( $result, $dbi );      
   
   // Definitions for downloading the MS-Analysis backup
   header( "Content-type: application/octetstream");
   header( "Content-Disposition: attachment; filename = $fn" );
   header( "pragma: no-cache" );
   header( "expires: 0" );      

   echo "#\n";
   echo "# Backup: " . $version . "\n";
   echo "# Date: " . date( "Y-m-d G:i:s" ). "\n";
   echo "# Database: " . $dbname . "\n";
   echo "#\n\n";
               
   MSAnalysisExportTable( $prefix."_msanalysis_admin" );     MSAnalysisExport( $prefix."_msanalysis_admin" );
   MSAnalysisExportTable( $prefix."_msanalysis_modules" );   MSAnalysisExport( $prefix."_msanalysis_modules" );
   MSAnalysisExportTable( $prefix."_msanalysis_referrals" ); MSAnalysisExport( $prefix."_msanalysis_referrals" );
   MSAnalysisExportTable( $prefix."_msanalysis_countries" ); MSAnalysisExport( $prefix."_msanalysis_countries" );
   MSAnalysisExportTable( $prefix."_msanalysis_browsers" );  MSAnalysisExport( $prefix."_msanalysis_browsers" );
   MSAnalysisExportTable( $prefix."_msanalysis_os" );        MSAnalysisExport( $prefix."_msanalysis_os" );
   MSAnalysisExportTable( $prefix."_msanalysis_search" );    MSAnalysisExport( $prefix."_msanalysis_search" );
   MSAnalysisExportTable( $prefix."_msanalysis_users" );     MSAnalysisExport( $prefix."_msanalysis_users" );
   MSAnalysisExportTable( $prefix."_msanalysis_online" );    MSAnalysisExport( $prefix."_msanalysis_online" );
   MSAnalysisExportTable( $prefix."_msanalysis_scr" );       MSAnalysisExport( $prefix."_msanalysis_scr" );
   MSAnalysisExportTable( $prefix."_msanalysis_domains" );   MSAnalysisExport( $prefix."_msanalysis_domains" );

   echo "# End of Backup-File " . $version . "\n";
}

/******************************************************************************/
/* FUNCTION: MSAnalysisExport( $table )                                       */
/* Export an MS-Analysis table contents                                       */
/******************************************************************************/
function MSAnalysisExport( $table )
{
   global $prefix, $dbi;

   echo "#\n";
   echo "# Dumping data for table `$table`\n";
   echo "#\n";

   $sql = "SELECT * FROM ".$table;
   $result = sql_query( $sql, $dbi );
   while( $row = sql_fetch_row( $result, $dbi ) ) {
      $insert = " INSERT INTO $table VALUES (";
      for( $j = 0; $j < mysql_num_fields( $result );$j++ ) {
         if( !isset( $row[ $j ] ) ) $insert .= "NULL,";
         else if($row[ $j ] != "" ) $insert .= "'".addslashes( $row[ $j ] )."',";
         else $insert .= "'',";
      }
      $insert = ereg_replace( ",$","",$insert );
      $insert .= ");\n";
      echo $insert;
   }
   echo "\n";
}

/******************************************************************************/
/* FUNCTION: MSAnalysisExportTable( $table )                                  */
/* Export an MS-Analysis table definition                                     */
/******************************************************************************/
function MSAnalysisExportTable( $table )
{
   global $dbname, $prefix, $dbi;
   
   echo "#\n";
   echo "# Table structure for table `$table`\n";
   echo "#\n";
   echo "DROP TABLE IF EXISTS $table;\n";
   echo "CREATE TABLE $table (\n";

   $tbuf = "";
   $result = mysql_db_query( $dbname, "SHOW FIELDS FROM $table" );
   while( $row = sql_fetch_array( $result, $dbi ) )
   {
       $tbuf .= "   $row[Field] $row[Type]";
       if( isset( $row[ "Default" ] ) && ( !empty( $row["Default"] ) || $row[ "Default" ] == "0" ) ) $tbuf .= " DEFAULT '$row[Default]'";
       if( $row[ "Null" ] != "YES" ) $tbuf .= " NOT NULL";
       if( $row[ "Extra" ] != "" ) $tbuf .= " $row[Extra]";
       $tbuf .= ",\n";
   }
   $tbuf = ereg_replace(",\n$", "", $tbuf );
   $result = mysql_db_query( $dbname, "SHOW KEYS FROM $table" );
   while( $row = sql_fetch_array( $result, $dbi ) )
   {
       $kname = $row['Key_name'];
       if( ( $kname != "PRIMARY") && ( $row['Non_unique'] == 0 ) ) $kname = "UNIQUE|$kname";
       if( !isset( $index[$kname] ) ) $index[$kname] = array();
       $index[$kname][] = $row['Column_name'];
   }

   while(list($x, $columns) = @each( $index ) )
   {
      $tbuf .= ",\n";
      if( $x == "PRIMARY" ) $tbuf .= "   PRIMARY KEY (" . implode($columns, ", ") . ")";
      elseif( substr($x,0,6) == "UNIQUE" ) $tbuf .= "   UNIQUE ".substr($x,7)." (" . implode($columns, ", ") . ")";
      else $tbuf .= "   KEY $x (" . implode($columns, ", ") . ")";
   }
	
   $tbuf .= "\n) TYPE=MyISAM;";
   echo ( stripslashes( $tbuf ) );
   echo "\n\n";
}

/***************************************************/
/****************** PROGRAM START ******************/
/***************************************************/
switch ( $op )
{
    case "MSAnalysisDump":
       MSAnalysisDump();
    break;    

    case "MSAnalysisExport":
       MSAnalysisExport( $table );
    break;

    case "MSAnalysisExportTable":
       MSAnalysisExportTable( $table );
    break;

    default:
       MSAnalysisDump();
}

} else { echo "Access Denied\n"; }

?>

