<?php

/************************************************************************************/
/*                                                                                  */
/* This class was originally written by:                                            */
/*                                                                                  */
/* Initial Version class.client.php by: Will Chapman (webmail@battlepages.com)      */
/* http://www.dreamscripts.net/index.php                                            */
/*                                                                                  */
/* Maty Scripts added and updated some of the routines for PHP-Nuke purposes        */
/*                                                                                  */
/************************************************************************************/
/*                                                                                  */
/* Maty Scripts Analysis for PHP-Nuke 6.5                                           */
/* v1.0: 17-03-2003                                                                 */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@matyscripts.com)                    */
/* http://www.matyscripts.com                                                       */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/

class client_info 
{ 
    var $platform;
    var $browser;
    var $robots;
    
    /******************************************************/
    /*                                                    */
    /* Constructor function client_info()                 */
    /*                                                    */
    /******************************************************/
    function client_info() 
    {
       $this->robots = array( "Alexibot", "asterias", "BackDoorBot", "Black.Hole", "BlowFish", "BotALot", "BuiltBotTough", "Bullseye",
                              "BunnySlippers", "Cegbfeieh", "CheeseBot", "CherryPicker", "CopyRightCheck", "cosmos", "crawler", "Crescent", "DittoSpyder",
                              "EmailCollector", "EmailSiphon", "EmailWolf", "EroCrawler", "ExtractorPro", "FAST-WebCrawler", "Foobot", 
                              "Googlebot", "Harvest", "hloader", "httplib", "humanlinks", "ia_archiver", "InfoNaviRobot", "JennyBot",
                              "Kenjin.Spider", "Keyword.Density", "LexiBot", "libWeb/clsHTTP", "LinkextractorPro", "LinkScan/8.1a.Unix",
                              "LinkWalker", "lwp-trivial", "Mata.Hari", "Microsoft.URL", "MIIxpc", "Mister.PiX", "moget", "Mozilla/3.Mozilla/2.01",
                              "Mozilla.*NEWT", "NetAnts", "NetMechanic", "NICErsPRO", "NPBot", "Offline.Explorer", "Openfind", "ProPowerBot/2.14",
                              "ProWebWalker ", "QueryN.Metasearch", "RepoMonkey", "RMA", "SiteSnagger", "SpankBot", "spanner", "suzuran", "Szukacz/1.4",
                              "Teleport", "Telesoft", "The.Intraformant", "TheNomad", "TightTwatBot", "Titan", "toCrawl/UrlDispatcher",
                              "True_Robot", "turingos", "TurnitinBot", "URLy.Warning", "VCI", "W3C_Validator", "W3C_CSS_Validator", "WebAuto",
                              "WebBandit", "WebCopier", "Webcrawler", "WebEMailExtrac", "WebEnhancer", "Web.Image.Collector", "WebmasterWorldForumBot",
                              "WebSauger", "Website.Quester", "Webster.Pro", "WebStripper", "WebWasher", "WebZip", "[Ww]eb[Bb]andit",
                              "WWW-Collector-E", "Xenu", "Zeus", "zyborg" ) ;

       $this->platform = "Unknown"; 
       // Determine the platform they are on 
       if (strstr($this->get_user_agent(),'Win'))  
	   {
           $this->platform="Windows";
           if ( preg_match("/5\.1/i", $this->get_user_agent() ) )
              $this->platform = "Windows XP";
           else if ( preg_match("/5\.0/i", $this->get_user_agent() ) )
              $this->platform = "Windows 2000";
           else if ( preg_match("/NT/i", $this->get_user_agent() ) )
              $this->platform = "Windows NT";              
           else if ( preg_match("/ME/i", $this->get_user_agent() ) )
              $this->platform = "Windows ME";
           else if ( preg_match("/Win 9x 4.90/i", $this->get_user_agent() ) )
              $this->platform = "Windows ME";
           else if ( preg_match("/Windows ME/i", $this->get_user_agent() ) )
              $this->platform = "Windows ME";				              
           else if ( preg_match("/98/i", $this->get_user_agent() ) )
              $this->platform = "Windows 98";
           else if ( preg_match("/95/i", $this->get_user_agent() ) )
              $this->platform = "Windows 95";
           else if ( preg_match("/Win16/i", $this->get_user_agent() ) )
              $this->platform = "Windows 3.1";
           else if ( preg_match("/Windows 3\.1/i", $this->get_user_agent() ) )
              $this->platform = "Windows 3.1";								
        } 
        else if (strstr($this->get_user_agent(), 'Mac' ) )
           $this->platform='Macintosh';
        else if (strstr($this->get_user_agent(), 'PPC' ) )
            $this->platform='Macintosh';
        else if (strstr($this->get_user_agent(), 'FreeBSD' ) )
            $this->platform='FreeBSD';
        else if (strstr($this->get_user_agent(), 'SunOS' ) )
            $this->platform='SunOS';
        else if (strstr($this->get_user_agent(), 'IRIX' ) )
            $this->platform='IRIX';
        else if (strstr($this->get_user_agent(), 'BeOS' ) )
            $this->platform='BeOS';
        else if (strstr($this->get_user_agent(), 'OS/2' ) )
            $this->platform='OS/2';
        else if (strstr($this->get_user_agent(), 'AIX' ) )
            $this->platform='AIX';
        else if (strstr($this->get_user_agent(), 'Linux' ) )
            $this->platform='Linux';
        else if (strstr($this->get_user_agent(), 'Unix' ) )
            $this->platform='Unix';
        else if (strstr($this->get_user_agent(), 'Amiga' ) )
            $this->platform='Amiga';            
        else 
            $this->platform='Other';
        
	// Opera (Disguised as MSIE)
       if ( preg_match("/Opera ([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found ) &&  strstr( $this->get_user_agent(), "MSIE" ) )
       $this->browser = "Opera " . $found[ 1 ]; 
             
	// Opera (Disguised as Netscape/Mozilla)
        else if ( preg_match("/Opera ([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found ) && strstr( $this->get_user_agent(), "Mozilla" ) )
           $this->browser = "Opera " . $found[ 1 ];
		
	// Opera (Itself)
        else if ( preg_match("/Opera\/([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found ) ) 
	   $this->browser = "Opera " . $found[ 1 ];
		
   	// Netscape 6.x
        else if ( preg_match("/Netscape[0-9]\/([0-9]{1,2}\.[0-9]{1,2})/i", $this->get_user_agent(), $found ) ) 
           $this->browser = "Netscape " . $found[ 1 ];

   	// Netscape 7.x
        else if ( preg_match("/Netscape\/([0-9]{1,2}\.[0-9]{1,2})/i", $this->get_user_agent(), $found ) ) 
           $this->browser = "Netscape " . $found[ 1 ];           

	// MSIE
        else if ( preg_match("/MSIE ([0-9]{1,2}\.[0-9]{1,2})/i", $this->get_user_agent(), $found ) )
           $this->browser = $found[0];

	// Konqueror
        else if ( preg_match("/Konqueror/i", $this->get_user_agent() ) ) 
           $this->browser = "Konqueror";

	// Galeon
	   else if ( preg_match("/Galeon/i", $this->get_user_agent() ) ) 
          $this->browser = "Galeon"; 

	// Phoenix
	   else if ( preg_match("/Phoenix\/([0-9]{1}\.[0-9]{1,2})/i", $this->get_user_agent(), $found ) ) 
          $this->browser = "Phoenix " . $found[ 1 ];

	// Lynx            
	   else if ( preg_match("/Lynx/i", $this->get_user_agent(), $found ) ) 
          $this->browser = "Lynx"; 

	// WebTV            
	   else if ( preg_match("/WebTV/i", $this->get_user_agent(), $found ) ) 
          $this->browser = "WebTV"; 

   	// Netscape 4.x
        else if ( preg_match("/Mozilla\/([0-9]{1}\.[0-9]{1,2}) \[en\]/i", $this->get_user_agent(), $found ) ) 
	   $this->browser = "Netscape " . $found[ 1 ];           

    // A different definition of Mozilla browsers
        else if ( preg_match("/Mozilla\/([0-9]{1,2}\.[0-9]{1,2})/i", $this->get_user_agent(), $found ) )
           $this->browser = "Mozilla " . $found[ 1 ];
	   
	// Mozilla
        else if ( preg_match("/(^Mozilla)(.)*\;\srv:([0-9]\.[0-9])/i", $this->get_user_agent(), $found ) )
           $this->browser = $found[ 1 ] . " " . $found[ 3 ];

	// Web Crawler
	   else if ( $this->chk_crawler() )
          $this->browser = "Web Crawler - " . $this->get_user_agent();           

	// Other (Dont know what is it)
       else 
          $this->browser = "Other"; 
    }
    
    /******************************************************/
    /*                                                    */
    /* function get_os()                                  */
    /*                                                    */
    /******************************************************/
    /* Return the platform detected                       */
    /******************************************************/
    function get_os() 
    { 
        return ( $this->platform ); 
    }

    /*****************************************************************/
    /*                                                               */
    /* function function chk_crawler()                               */
    /*                                                               */
    /*****************************************************************/
    /* Compare agent string with a list of known web crawlers/robots */
    /*****************************************************************/
    function chk_crawler()
    {
       foreach( $this->robots as $value )
          if( preg_match("/" . $value . "/i", $this->get_user_agent() ) )
             return true; 
       return false;
    }
            
    /******************************************************/
    /*                                                    */
    /* function get_browser()                             */
    /*                                                    */
    /******************************************************/
    /* Return the browser that we detected                */
    /******************************************************/
    function get_browser() 
    { 
       return ( $this->browser ); 
    } 

    /******************************************************/
    /*                                                    */
    /* function get_user_agent()                          */
    /*                                                    */
    /******************************************************/
    /* Return the user agent string                       */
    /******************************************************/
    function get_user_agent() 
    { 
       return getenv( "HTTP_USER_AGENT" );
    } 

    /******************************************************************************/
    /* FUNCTION: get_ip()                                                         */
    /* Return users real IP address                                               */
    /******************************************************************************/   
    function get_ip()
    {
       // Get useful vars
       if( isset( $_SERVER ) ) {
          $client_ip = $_SERVER['HTTP_CLIENT_IP'];
          $x_forwarded_for = $_SERVER['HTTP_X_FORWARDED_FOR'];
          $remote_addr = $_SERVER['REMOTE_ADDR'];
       }
       else {
          $client_ip = getenv( 'HTTP_CLIENT_IP' );
          $x_forwarded_for = getenv( 'HTTP_X_FORWARDED_FOR' );
          $remote_addr = getenv( 'REMOTE_ADDR' );
       }

       // Then the script itself
       if( !empty( $client_ip ) ) {
          $ip_expl = explode( '.', $client_ip );
          $referer = explode( '.', $remote_addr );
          if( $referer[0] != $ip_expl[0] ) {
             $ip = array_reverse( $ip_expl );
             $real_ip = implode( '.', $ip );
          }
          else {
             $real_ip = $client_ip;
          };
       }
       elseif( !empty( $x_forwarded_for ) ) {
          if( strstr( $x_forwarded_for, ',' ) ) {
             $ip_expl = explode( ',', $x_forwarded_for );
             $real_ip = end( $ip_expl );
          }
          else {
             $real_ip = $x_forwarded_for;
          };
       }
       else {
          $real_ip = $remote_addr;
       };
       return $real_ip;
    }

    /******************************************************************************/
    /* FUNCTION: get_host()                                                       */
    /* Return users hostname                                                      */
    /******************************************************************************/   
    function get_host( $ip )
    {
       $host = @getHostByAddr( $ip );
       if( empty( $host ) ) {
          if( isset( $_SERVER ) ) {	$remote_addr = $_SERVER['REMOTE_ADDR']; }
          else { $remote_addr = getenv( 'REMOTE_ADDR' ); }
          $host = @getHostByAddr( $remote_addr );
       }
       return $host;
    }    
    
    /******************************************************************************/
    /* FUNCTION: GetSearchWords                                                   */
    /* Return searchwords                                                         */
    /******************************************************************************/
    function GetSearchWords( $fullname, $onlyhost, $search_store )
    {
       include(dirname(__FILE__) . '/searchengines.php' );

       $searchwords = "";
       foreach( $MSSearchEngines as $key=>$value ) {
          if( eregi( $key, $onlyhost ) ) {
             $url = parse_url( $fullname );
             $query = $url['query'];
             $query = explode( "&", $query );          	
             for( $j = 0; $j < sizeof( $query ); $j++ )
             {
                $fquery = explode( "=" , $query[ $j ] );
                if( $fquery[ 0 ] == $value ) {
	               $searchwords = trim(strtolower(urldecode( $fquery[ 1 ] ) ) );
	               $searchwords = str_replace( "\"", "", $searchwords );
	               if( $search_store ) $searchwords = str_replace( "+", " ", $searchwords );
	               break;
                }
             } // END sizeof( $query )
          } // END eregi
       }
       return( $searchwords );       
    } // END Function

    /******************************************************************************/
    /* FUNCTION: IsSearchEngine( $referral )                                      */
    /* Return 1 if $referral is a Search Engine else 0                            */
    /******************************************************************************/
    function IsSearchEngine( $referral )
    {
       include(dirname(__FILE__) . '/searchengines.php' );
       
       $se = 0;
       foreach( $MSSearchEngines as $key=>$value ) { if( eregi( $key, $referral ) ) { $se = 1; } }
       return( $se );
    }
                          
} 

?> 