<?php

/************************************************************************************/
/* PHP-NUKE: Web Portal System                                                      */
/* ===========================                                                      */
/*                                                                                  */
/* Copyright (c) 2002 by Francisco Burzi                                            */
/* http://phpnuke.org                                                               */
/*                                                                                  */
/* MostMonth /MostDay / MostHour Routines are from PHP-Nuke 6.0 Statistics          */
/************************************************************************************/
/*                                                                                  */
/* Maty Scripts Analysis for PHP-Nuke 6.5                                           */
/* v1.0: 17-03-2003                                                                 */
/*                                                                                  */
/* Copyright  2002 by: Maty Scripts (webmaster@matyscripts.com)                    */
/* http://www.matyscripts.com                                                       */
/*                                                                                  */
/* This program is free software. You can redistribute it and/or modify             */
/* it under the terms of the GNU General Public License as published by             */
/* the Free Software Foundation; either version 2 of the License.                   */
/*                                                                                  */
/************************************************************************************/
include(dirname(__FILE__) . '/searchengines.php' );
              
class msanalysis
{
    var $l_size;
    var $m_size;
    var $r_size;

    /******************************************************************************/
    /* Constructor for this Class                                                 */
    /******************************************************************************/
    function msanalysis()
    {
       global $ThemeSel;

       $this->l_size = getimagesize("themes/$ThemeSel/images/leftbar.gif");
       $this->m_size = getimagesize("themes/$ThemeSel/images/mainbar.gif");
       $this->r_size = getimagesize("themes/$ThemeSel/images/rightbar.gif");
    }

    /******************************************************************************/
    /* FUNCTION: MSAnalysisDaysOld( $enterdate )                                  */
    /* Return how many days ago a user was on-line                                */
    /******************************************************************************/
    function DaysOld( $enterdate )
    {
	   $enterdate = substr( $enterdate, 0, 10 ) . " 00:00:00";
       $date_secs = strtotime( $enterdate );
       // get the value of right now
       $now = time();
       // compute the difference
       $timediff = $date_secs - $now;
       //get the int val of the days passed
       $dayspassed = intval( abs( ( ( ( $timediff / 60 ) / 60 ) / 24 ) ) );
       return( $dayspassed );
    } // END function MSAnalysisDaysOld( $enterdate )


    /******************************************************************************/
    /* FUNCTION: IsSearchEngine( $referral )                                      */
    /* Return 1 if $referral is a Search Engine else 0                            */
    /******************************************************************************/
    function IsSearchEngine( $referral )
    {
	   global $MSSearchEngines;
	   
       $se = 0;
       foreach( $MSSearchEngines as $key=>$value ) { if( eregi( $key, $referral ) ) { $se = 1; } }
       return( $se );
	   //return( client_info::IsSearchEngine( $referral ) );
    }

    /******************************************************************************/
    /* FUNCTION: GetBrowserPicture( $ibrowser )                                   */
    /* Return name of browser image to display                                    */
    /******************************************************************************/
    function GetBrowserPicture( $ibrowser )
    {    
       if( eregi( "msie", $ibrowser ) )           { $sym = "msie";      } 
	   else if( eregi( "konqueror", $ibrowser ) ) { $sym = "konqueror"; }
	   else if( eregi( "netscape", $ibrowser ) )  { $sym = "netscape";  }
	   else if( eregi( "opera", $ibrowser ) )     { $sym = "opera";     }
       else if( eregi( "webtv", $ibrowser ) )     { $sym = "webtv";     }
	   else if( eregi( "lynx", $ibrowser ) )      { $sym = "lynx";      }					
	   else if( eregi( "mozilla", $ibrowser ) )   { $sym = "mozilla";   }
       else if( eregi( "galeon", $ibrowser ) )    { $sym = "galeon";    }
       else if( eregi( "phoenix", $ibrowser ) )   { $sym = "phoenix";   }       
	   else                                       { $sym = "blank";     }
   
	   return( $sym );
	}

    /******************************************************************************/
    /* FUNCTION: CountBrowserTypes( )                                             */
    /* Count the browsers per type                                                */
    /******************************************************************************/
    function CountBrowserTypes( )
    {    
       global $db, $prefix;
       $sym1 = 0; $sym2 = 0; $sym3 = 0; $sym4 = 0; $sym5 = 0; $sym6 = 0; $sym7 = 0; $sym8 = 0; $sym9 = 0; 
       $result = $db->sql_query( "select id, ibrowser, hits from $prefix"._msanalysis_browsers." order by hits DESC" );
       while( ( list( $id, $ibrowser, $hits ) = $db->sql_fetchrow( $result ) ) ) {
          if( ! eregi( "Web Crawler", $ibrowser ) ) {
             if( eregi( "msie", $ibrowser ) )           { $sym1 = $sym1 + $hits; } 
	         else if( eregi( "konqueror", $ibrowser ) ) { $sym2 = $sym2 + $hits; } 
             else if( eregi( "netscape", $ibrowser ) )  { $sym3 = $sym3 + $hits; } 
	         else if( eregi( "opera", $ibrowser ) )     { $sym4 = $sym4 + $hits; } 
             else if( eregi( "webtv", $ibrowser ) )     { $sym5 = $sym5 + $hits; } 
	         else if( eregi( "lynx", $ibrowser ) )      { $sym6 = $sym6 + $hits; } 				
	         else if( eregi( "mozilla", $ibrowser ) )   { $sym7 = $sym7 + $hits; } 
             else if( eregi( "galeon", $ibrowser ) )    { $sym8 = $sym8 + $hits; } 
             else if( eregi( "phoenix", $ibrowser ) )   { $sym9 = $sym9 + $hits; }
          }
       }
	   return( "19|$sym1|MSIE|$sym2|Konqueror|$sym3|Netscape|$sym4|Opera|$sym5|Webtv|$sym6|Lynx|$sym7|Mozilla|$sym8|Galeon|$sym9|Phoenix" );
	}	
	
    /******************************************************************************/
    /* FUNCTION: GetOSPicture( $ios )                                             */
    /* Return name of operating image to display                                  */
    /******************************************************************************/
    function GetOSPicture( $ios )
    {    
       if( eregi( "Macintosh", $ios ) )    { $sym = "mac";     } 
  	   else if( eregi( "FreeBSD", $ios ) ) { $sym = "bsd";     }
	   else if( eregi( "SunOS", $ios ) )   { $sym = "sun";     }
	   else if( eregi( "IRIX", $ios ) )    { $sym = "irix";    }
	   else if( eregi( "BeOS", $ios ) )    { $sym = "be";      }
	   else if( eregi( "OS/2", $ios ) )    { $sym = "os2";     }
	   else if( eregi( "AIX", $ios ) )     { $sym = "aix";     }
	   else if( eregi( "Amiga", $ios ) )   { $sym = "amiga";   }
	   else if( eregi( "Linux", $ios ) )   { $sym = "linux";   }
	   else if( eregi( "Unix", $ios ) )    { $sym = "linux";   }
	   else if( eregi( "Windows", $ios ) ) { $sym = "windows"; }
	   else                                { $sym = "blank";   }
   
	   return( $sym );
	}    	
	    
   /******************************************************************************/
   /* FUNCTION: GetMonth()                                                       */
   /* Convert month number to text month                                         */
   /******************************************************************************/
   function GetMonth( $month )
   {
      if ($month == 1)  return ""._MSA_JANUARY."";
      if ($month == 2)  return ""._MSA_FEBRUARY."";
      if ($month == 3)  return ""._MSA_MARCH."";
      if ($month == 4)  return ""._MSA_APRIL."";
      if ($month == 5)  return ""._MSA_MAY."";
      if ($month == 6)  return ""._MSA_JUNE."";
      if ($month == 7)  return ""._MSA_JULY."";
      if ($month == 8)  return ""._MSA_AUGUST."";
      if ($month == 9)  return ""._MSA_SEPTEMBER."";
      if ($month == 10) return ""._MSA_OCTOBER."";
      if ($month == 11) return ""._MSA_NOVEMBER."";
      if ($month == 12) return ""._MSA_DECEMBER."";
   } // End function GetMonth()    

   /******************************************************************************/
   /* FUNCTION: PruneOnline( $max_online )                                       */
   /* Delete online entries. Set to: $max_online                                 */
   /******************************************************************************/   
   function PruneOnline( $max_online )
   {
      global $prefix, $db;

      // Delete online entries. Set to: $max_online
      $counter = 0;   
      $result = $db->sql_query( "select uid, oldate from $prefix"._msanalysis_online." order by oldate DESC" );
      while( (list( $uid, $oldate ) = $db->sql_fetchrow( $result ) ) ) {
         if( $counter >= $max_online ) {
            $result1 = $db->sql_query( "DELETE FROM $prefix"._msanalysis_online." WHERE uid='$uid'" );
         }
         $counter += 1;
      }
      $db->sql_freeresult( $result );
      $db->sql_query( "OPTIMIZE TABLE $prefix"._msanalysis_online."" );
   }
   
   /******************************************************************************/
   /* FUNCTION: TotalHits                                                        */
   /* Return total amount of hits for a certain overview                         */
   /******************************************************************************/
   function TotalHits( $screen )
   {
      global $db, $prefix;
      $counter = 0;
      switch( $screen )
      {
         case 1:
            $result = $db->sql_query( "select hits from $prefix"._msanalysis_countries );
            while( list( $hits ) = $db->sql_fetchrow( $result ) ) $counter = $counter + $hits;
         break;
         case 2:
            $result = $db->sql_query( "select referral, hits from $prefix"._msanalysis_referrals );
            while(list( $referral, $hits ) = $db->sql_fetchrow( $result ) ) {
	           if( $this->IsSearchEngine( $referral ) == 0 ) { $counter = $counter + $hits; }  
            }
	     break;
         case 3:
            $result = $db->sql_query( "select referral, hits from $prefix"._msanalysis_referrals );
            while(list( $referral, $hits ) = $db->sql_fetchrow( $result ) ) {
	           if( $this->IsSearchEngine( $referral ) == 1 ) { $counter = $counter + $hits; }
            }
	     break;
         case 4:
            $result = $db->sql_query( "select ibrowser, hits from $prefix"._msanalysis_browsers );
            while( list( $ibrowser, $hits ) = $db->sql_fetchrow( $result ) ) {
               if( ! eregi( "Other", $ibrowser ) ) { $counter = $counter + $hits; }
            }
	     break;
         case 5:
            $result = $db->sql_query( "select hits from $prefix"._msanalysis_os );
            while( list( $hits ) = $db->sql_fetchrow( $result ) ) $counter = $counter + $hits;
	     break;
         case 6:
            $result = $db->sql_query( "select hits from $prefix"._msanalysis_modules );
            while( list( $hits ) = $db->sql_fetchrow( $result ) ) $counter = $counter + $hits;
	     break;
         case 8:
            $result = $db->sql_query( "select hits from $prefix"._msanalysis_search );
            while( list( $hits ) = $db->sql_fetchrow( $result ) ) $counter = $counter + $hits;
	     break;
         case 9:
            $result = $db->sql_query( "select hits from $prefix"._msanalysis_scr );
            while( list( $hits ) = $db->sql_fetchrow( $result ) ) $counter = $counter + $hits;
	     break;
      }
      
      if( $counter == 0 ) $counter = 1;
      return $counter;
   } // END function TotalHits( $screen )

   /******************************************************************************/
   /* FUNCTION: TotalDownloads                                                   */
   /* Return total amount of Downloads + how often downloaded                    */
   /******************************************************************************/
   function TotalDownloads( )
   {   
      global $db, $prefix;
      $dresult=0;
      $result = $db->sql_query( "select lid, hits from $prefix"._downloads_downloads." order by lid" );
      while( list( $lid, $hits ) = $db->sql_fetchrow( $result ) )  { $dresult = $dresult + $hits; }
      $result = $db->sql_query( "select * from $prefix"._downloads_downloads."" );
      $numrows = $db->sql_numrows( $result );
      return( "$numrows|$dresult" );
   }

   /******************************************************************************/
   /* FUNCTION: TotalMBDownloads                                                 */
   /* Return total amount of MegaBytes Downloaded                                */
   /******************************************************************************/
   function TotalMBDownloads( )
   {   
      global $db, $prefix;
         
      $totaldownloadsize = 0;
      $dresult = $db->sql_query( "select hits, filesize from ".$prefix."_downloads_downloads" );
      while( list( $hits, $filesize ) = $db->sql_fetchrow( $dresult ) )
      {
         $downloadsize = $hits * $filesize;
         $totaldownloadsize += $downloadsize;
      }
      return( sprintf("%01.2f", $totaldownloadsize / ( 1024 * 1024 ) ) );
   }
   
   /******************************************************************************/
   /* FUNCTION: TotalVisits                                                      */
   /* Return total amount of Page Visits                                         */
   /******************************************************************************/
   function TotalVisits( )
   {   
      global $db, $prefix;
      $result = $db->sql_query( "select count from ".$prefix."_counter where type = 'total'" );
      list( $count ) = $db->sql_fetchrow( $result );
      return( $count + 1 );
   }

   /******************************************************************************/
   /* FUNCTION: MostMonth                                                        */
   /* Return Highest pagevisits in a Month                                       */
   /******************************************************************************/
   function MostMonth( )
   {   
      global $db, $prefix;
      $result = $db->sql_query( "select year, month, hits from ".$prefix."_stats_month order by hits DESC limit 0,1" );
      list( $year, $month, $hits ) = $db->sql_fetchrow( $result );
      $month = $this->GetMonth( $month );
      return( ""._MSA_MOSTMONTH.": $month $year ($hits "._MSA_HITS.")<br>" );
   }

   /******************************************************************************/
   /* FUNCTION: MostDay                                                          */
   /* Return Highest pagevisits in a Day                                         */
   /******************************************************************************/
   function MostDay( )
   {   
      global $db, $prefix;
      $result = $db->sql_query( "select year, month, date, hits from ".$prefix."_stats_date order by hits DESC limit 0,1" );
      list( $year, $month, $date, $hits ) = $db->sql_fetchrow( $result );
      $month = $this->GetMonth( $month );
      return( ""._MSA_MOSTDAY.": $date $month $year ($hits "._MSA_HITS.")<br>" );
   }

   /******************************************************************************/
   /* FUNCTION: MostHour                                                         */
   /* Return Highest pagevisits in an Hour                                       */
   /******************************************************************************/
   function MostHour( )
   {   
      global $db, $prefix;
      $result = $db->sql_query( "select year, month, date, hour, hits from ".$prefix."_stats_hour order by hits DESC limit 0,1" );
      list( $year, $month, $date, $hour, $hits ) = $db->sql_fetchrow( $result );
      $month = $this->GetMonth( $month );
      if( $hour < 10 ) { $hour = "0$hour:00 - 0$hour:59"; } else { $hour = "$hour:00 - $hour:59"; }
      return( ""._MSA_MOSTHOUR.": $hour "._MSA_ON." $month $date, $year ($hits "._MSA_HITS.")<br>" );
   }   



   
      

} 

?> 